/*----------------------------------------------------------------------------
 15.08.16, Harald Peters, TFA_RFM69; Mega328 luft mit 3.3V
// Mega328: FuseBitsE: statt F9h FDh (BOD=2.7V)
// Mega328, FuseBitsH: statt DFh D6h (EE nicht lschen; 512Byte Bootloader  PB0/PB1 32256 Bytes frei)
// Mega328, FuseBitsL: statt 62h FFh (8MHz, extern, 1:1)
// Timer0 ( 8Bit): OOK-Dekodierung RFM69
// RFM69 SPI; NSS an PB2; IO2 an PD2
----------------------------------------------------------------------------*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdarg.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "RFM69.h"

int16_t Temp, Regen;
uint8_t Feucht,Wind, Boe;
uint8_t Tag,Mon,Jhr, Std,Min,Sek;


uint8_t BcdToDec(uint8_t val)
{ 
 return( (val/16*10) + (val%16) ); 
}


void AusgabeOOK() // wenn RFM69-Tel empfangen
{
 RFM69Stat &= ~0x20;
 if (FBlock.BitZ>40) 
 {
  FAnalyse();
//  Print("%xh %3d b2=%d f=%xh x=%xh\r\n",FbTyp,FBlock.BitZ,FBlock.Bit2Start,FBlock.Fehl,FBlock.x);
//  Print("%10h \r\n",&FBlock.TelBytes[0]);
//  if (FBlock.BitZ>90) Print("%10h\r\n",&FBlock.TelBytes[1]);
  if ((FBlock.TelBytes[0][1]&0xF0)==0x50) 
  {
   Temp = 256*(FBlock.TelBytes[0][2]&0x0F) + FBlock.TelBytes[0][3]; // in 0.1C
   Temp = Temp-400;
   Feucht = FBlock.TelBytes[0][4]; // in %
   Regen = 256*FBlock.TelBytes[0][7]+FBlock.TelBytes[0][8]; // mu durch 4 geteilt werden in mm
   Boe = FBlock.TelBytes[0][5];
   Wind = FBlock.TelBytes[0][6];
//   Print("T=%j H=%d%% R=%d W=%d B=%d\r\n",Temp,Feucht,Regen,Wind,Boe);
  }
  if ((FBlock.TelBytes[0][1]&0xF0)==0x60) 
  {
   Tag = BcdToDec(FBlock.TelBytes[0][8]);
   Mon = BcdToDec(FBlock.TelBytes[0][7]&0x1F);
   Jhr = BcdToDec(FBlock.TelBytes[0][6]);
   Std = BcdToDec(FBlock.TelBytes[0][3]);
   Min = BcdToDec(FBlock.TelBytes[0][4]);
   Sek = BcdToDec(FBlock.TelBytes[0][5]);
//   Print("%I.%I.%I %I:%I:%I\r\n",Tag,Mon,Jhr, Std,Min,Sek);
  }
  
//  SendLf();
 }
 StartStoppFunk(2);
}


int main(void)
{
 PORTB  = (1<<PB2);
 DDRB   = (1<<PB2);
 sei();


 RFM69InitOOK();
 if (RFM69Vers==0x24) 
 {
//  Print("RFM69-Init Ok\r\n");
  StartStoppFunk(2);
 }

 while(1)
 {
  if (RFM69Stat&0x06) OOKFlanke();
  if (RFM69Stat&0x20) AusgabeOOK();
 } // while

 return(0);
}




